module Yorinter
  DEFAULT_INPUT_FORMAT  = 'erb'
  DEFAULT_OUTPUT_FORMAT = 'html'

  module Printable
    def print params = {}, options = {}
      input_format = self.input_format || DEFAULT_INPUT_FORMAT
      output_format = params[:format] || self.output_format || DEFAULT_OUTPUT_FORMAT

      engine_class = Engine.search_engine input_format, output_format

      raise 'Not convertable' unless engine_class

      engine = engine_class.new(self, params, options).render
    end
  end
end
